﻿using ProjectAirFighter.Drawnings;
using ProjectAirFighter.Exceptions;

namespace ProjectAirFighter.CollectionGenericObjects;

/// <summary>
/// Реализация абстрактной компании - СимбирФлот
/// </summary>
public class AirCraftAngar : AbstractCompany
{
    /// <summary>
    /// Конструктор
    /// </summary>
    /// <param name="picWidth"></param>
    /// <param name="picHeight"></param>
    /// <param name="collection"></param>
    public AirCraftAngar(int picWidth, int picHeight, ICollectionGenericObjects<DrawningAirCraft> collection) : base(picWidth, picHeight, collection)
    {
    }
    /// <summary>
    /// Отрисовка хранилища
    /// </summary>
    /// <param name="g">Графика</param>
    int pamat_i = 0;
    int pamat_j = 0;
    protected override void DrawBackgound(Graphics g)
    {
        Pen pen = new(Color.Black, 4);
        for (int i = 0; i < _pictureWidth / _placeSizeWidth; i++)
        {
            pamat_i = i;
            for (int j = 0; j < _pictureHeight / _placeSizeHeight; j++)
            {
                pamat_j = j;
                g.DrawLine(pen, new(_placeSizeWidth * i, _placeSizeHeight * j), new((int)(_placeSizeWidth * (i + 0.5f)), _placeSizeHeight * j));
                g.DrawLine(pen, new(_placeSizeWidth * i, _placeSizeHeight * j), new(_placeSizeWidth * i, _placeSizeHeight * (j + 1)));
            }
            g.DrawLine(pen, new(_placeSizeWidth * i, _placeSizeHeight * (_pictureHeight / _placeSizeHeight)), new((int)(_placeSizeWidth * (i + 0.5f)), _placeSizeHeight * (_pictureHeight / _placeSizeHeight)));
        }


    }
    /// <summary>
    /// Установка объекта в Ангар
    /// </summary>
    protected override void SetObjectsPosition()
    {
        int currentIndex = 0;
        for (int j = pamat_j; j >= 0; j--)
        {
            for (int i = pamat_i; i >= 0; i--)
            {
                try
                {
                    if (_collection?.Get(currentIndex) != null)
                    {
                        _collection.Get(currentIndex)?.SetPictureSize(_pictureWidth, _pictureHeight);
                        _collection.Get(currentIndex)?.SetPosition(i * _placeSizeWidth + 5, j * _placeSizeHeight + 5);
                    }
                }
                catch (ObjectNotFoundException)
                {

                }
                currentIndex++;
            }
        }
    }
}