﻿namespace ProjectAirFighter.Drawnings;
public class DrawningAirCraftCompareByColor : IComparer<DrawningAirCraft?>
{
    public int Compare(DrawningAirCraft? x, DrawningAirCraft? y)
    {
        if (x == null || x.EntityAirCraft == null)
        {
            return 1;
        }

        if (y == null || y.EntityAirCraft == null)
        {
            return -1;
        }
        var bodycolorCompare = x.EntityAirCraft.BodyColor.Name.CompareTo(y.EntityAirCraft.BodyColor.Name);
        if (bodycolorCompare != 0)
        {
            return bodycolorCompare;
        }
        var speedCompare = x.EntityAirCraft.Speed.CompareTo(y.EntityAirCraft.Speed);
        if (speedCompare != 0)
        {
            return speedCompare;
        }
        return x.EntityAirCraft.Weight.CompareTo(y.EntityAirCraft.Weight);
    }
}