﻿using ProjectAirFighter.Drawnings;

public class DrawingAirCraftCompareByType : IComparer<DrawningAirCraft?>
{
    public int Compare(DrawningAirCraft? x, DrawningAirCraft? y)
    {
        if (x == null && y == null) return 0;
        if (x == null || x.EntityAirCraft == null)
        {
            return 1;
        }

        if (y == null || y.EntityAirCraft == null)
        {
            return -1;
        }

        if (x.GetType().Name != y.GetType().Name)
        {
            return x.GetType().Name.CompareTo(y.GetType().Name);
        }

        var speedCompare = x.EntityAirCraft.Speed.CompareTo(y.EntityAirCraft.Speed);
        if (speedCompare != 0)
        {
            return speedCompare;
        }

        return x.EntityAirCraft.Weight.CompareTo(y.EntityAirCraft.Weight);
    }
}