﻿using ProjectAirFighter.Entities;
using System.Diagnostics.CodeAnalysis;

namespace ProjectAirFighter.Drawnings;

/// <summary>
/// Реализация сравнения двух объектов класса-прорисовки
/// </summary>
public class DrawningAirCraftEqutables : IEqualityComparer<DrawningAirCraft?>
{
    public bool Equals(DrawningAirCraft? x, DrawningAirCraft? y)
    {
        if (x == null || x.EntityAirCraft == null)
        {
            return false;
        }

        if (y == null || y.EntityAirCraft == null)
        {
            return false;
        }

        if (x.GetType().Name != y.GetType().Name)
        {
            return false;
        }

        if (x.EntityAirCraft.Speed != y.EntityAirCraft.Speed)
        {
            return false;
        }

        if (x.EntityAirCraft.Weight != y.EntityAirCraft.Weight)
        {
            return false;
        }

        if (x.EntityAirCraft.BodyColor != y.EntityAirCraft.BodyColor)
        {
            return false;
        }

        if (x is DrawningAirFighter && y is DrawningAirFighter)
        {
            EntityAirFighter entityX = (EntityAirFighter)x.EntityAirCraft;
            EntityAirFighter entityY = (EntityAirFighter)y.EntityAirCraft;
            if (entityX.Pgo != entityY.Pgo)
            {
                return false;
            }
            if (entityX.Rockets != entityY.Rockets)
            {
                return false;
            }
            if (entityX.AdditionalColor != entityY.AdditionalColor)
            {
                return false;
            }
        }

        return true;
    }

    public int GetHashCode([DisallowNull] DrawningAirCraft obj)
    {
        return obj.GetHashCode();
    }
}